summaryrefslogtreecommitdiffstats
path: root/conf
diff options
context:
space:
mode:
authorManjunath Ranganathaiah <manjunath.ranganathaiah@intel.com>2018-04-03 16:29:45 -0700
committerManjunath Ranganathaiah <manjunath.ranganathaiah@intel.com>2018-04-03 16:34:03 -0700
commit54944fe6c6371e73fb01d3a5a0131d5fb5d6ee36 (patch)
tree68be5b199c971317748e8599693bc9defe167fa3 /conf
parent1ef69d23678f12c3c78e85c5b4579e305862ed8e (diff)
pkcs11 key/cert import for CA use
Issue-ID: AAF-203 Change-Id: I07b5100ce46788a423be8bfa663368dece40d901 Signed-off-by: Manjunath Ranganathaiah <manjunath.ranganathaiah@intel.com>
Diffstat (limited to 'conf')
-rw-r--r--conf/CA/cfg.pkcs113
-rwxr-xr-xconf/CA/p11.sh39
2 files changed, 42 insertions, 0 deletions
diff --git a/conf/CA/cfg.pkcs11 b/conf/CA/cfg.pkcs11
new file mode 100644
index 00000000..0c12c6bf
--- /dev/null
+++ b/conf/CA/cfg.pkcs11
@@ -0,0 +1,3 @@
+name = shsm
+library = /usr/lib/x86_64-linux-gnu/softhsm/libsofthsm2.so
+slot = 0
diff --git a/conf/CA/p11.sh b/conf/CA/p11.sh
new file mode 100755
index 00000000..fdc0a3f9
--- /dev/null
+++ b/conf/CA/p11.sh
@@ -0,0 +1,39 @@
+#
+# Import the keys and certs to pkcs11 based softhsm
+#
+
+if [ "$#" -ne 3 ]; then
+ echo "Usage: p11.sh <user pin> <so pin> <id>"
+ exit 1
+fi
+
+LIB_PATH=/usr/lib/x86_64-linux-gnu/softhsm/libsofthsm2.so
+
+mkdir -p p11key p11crt cacerts
+# Conver the keys and certs to DER format
+# key to der
+openssl rsa -in private/ca.key -outform DER -out p11key/cakey.der
+# cert to der
+cp certs/ca.crt cacerts
+DLIST=`ls -d intermediate_*`
+for DIR in $DLIST; do
+ cp $DIR/certs/ca.crt cacerts/$DIR.crt
+done
+for CA in `ls cacerts`; do
+ openssl x509 -in cacerts/$CA -outform DER -out p11crt/$CA
+done
+
+# create token directory
+mkdir /var/lib/softhsm/tokens
+# create slot
+softhsm2-util --init-token --slot 0 --label "ca token" --pin $1 --so-pin $2
+# import key into softhsm
+pkcs11-tool --module $LIB_PATH -l --pin $1 --write-object p11key/cakey.der --type privkey --id $3
+# import certs into softhsm
+for CRT in `ls cacerts`; do
+ pkcs11-tool --module $LIB_PATH -l --pin $1 --write-object p11crt/$CRT --type cert --id $3
+done
+
+rm -r p11key
+rm -r p11crt
+rm -r cacerts